(function() {
  /*
    LRU cache
  */  var DEFAULT_OPTIONS, LRU, utils;
  utils = require('../index/utils');
  DEFAULT_OPTIONS = {
    maxSize: 400,
    normalSize: 300
  };
  exports.LRU = LRU = function(options) {
    var _ref;
    _ref = utils.merge(DEFAULT_OPTIONS, options), this.maxSize = _ref.maxSize, this.normalSize = _ref.normalSize;
    this.hashmap = {};
    this.keys = [];
    return this.keysLen = 0;
  };
  LRU.prototype.set = function(key, value) {
    var existing, hashmap, keys, rest;
    hashmap = this.hashmap;
    existing = hashmap[key];
    if (existing) {
      existing.fitness++;
    } else {
      keys = this.keys;
      keys.push(hashmap[key] = {
        fitness: this.keysLen / 10,
        key: key,
        value: value
      });
      if (++this.keysLen > this.maxSize) {
        keys.sort(function(a, b) {
          if (a.fitness < b.fitness) {
            return 1;
          } else if (a.fitness === b.fitness) {
            return 0;
          } else {
            return -1;
          }
        });
        rest = keys.slice(this.normalSize);
        this.keys = keys.slice(0, this.normalSize);
        rest.forEach(function(item) {
          return delete hashmap[item.key];
        });
        this.keysLen = this.normalSize;
      }
    }
    return value;
  };
  LRU.prototype.get = function(key) {
    var existing;
    existing = this.hashmap[key];
    if (existing) {
      existing.fitness++;
      return existing.value;
    } else {
      return;
    }
  };
}).call(this);
